# Generated by Django 4.0 on 2022-11-04 21:10

from django.db import migrations, models
import django.db.models.deletion
import finanztool.core.models.annual_plan

# statuses from old request
NEW = 1
OFFERS_NEEDED = 3
ZA3_REQUESTED = 4
APPROVED = 5
DECLINED = 6
FINISHED = 7


def split_budget_request(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    Budget = apps.get_model("core", "Budget")
    Request = apps.get_model("core", "Request")
    ReceivedInvoice = apps.get_model("core", "ReceivedInvoice")

    db_alias = schema_editor.connection.alias
    for request in Request.objects.using(db_alias).all():
        budget = Budget(
            annual_plan=request.annual_plan,
            requester=request.requester,
            target=-request.estimated_amount,
            note="Auto-created by migration",
            name=request.name,
            date=request.date,
        )
        budget.status = {
            NEW: "requested",
            OFFERS_NEEDED: "requested",
            ZA3_REQUESTED: "requested",
            APPROVED: "approved",
            DECLINED: "closed",
            FINISHED: "closed",
        }[request.status]
        budget.save()
        request.budget = budget
        request.za3_requested = request.status == ZA3_REQUESTED
        request.save()

        for inv in ReceivedInvoice.objects.using(db_alias).filter(request=request):
            inv.budget = budget
            inv.save()


class Migration(migrations.Migration):

    dependencies = [
        ("core", "0111_alter_issuedinvoice_monition"),
    ]

    operations = [
        migrations.AddField(
            model_name="request",
            name="za3_requested",
            field=models.BooleanField(default=False, verbose_name="Angefragt bei ZA3"),
        ),
        migrations.CreateModel(
            name="Budget",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("target", models.DecimalField(decimal_places=2, max_digits=32, verbose_name="Zielvorgabe")),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("requested", "Beantragt"),
                            ("approved", "Genehmigt"),
                            ("done", "Ausgeschöpft"),
                            ("closed", "Geschlossen"),
                        ],
                        default="requested",
                        max_length=16,
                        verbose_name="Status",
                    ),
                ),
                ("note", models.TextField(blank=True, help_text="Interne Notiz", verbose_name="Notiz")),
                ("name", models.CharField(max_length=100)),
                ("description", models.TextField(blank=True, verbose_name="Beschreibung")),
                ("date", models.DateField(auto_now_add=True, verbose_name="Erstellungsdatum")),
                (
                    "annual_plan",
                    models.ForeignKey(
                        default=finanztool.core.models.annual_plan.AnnualPlan.get_current,
                        on_delete=django.db.models.deletion.PROTECT,
                        to="core.annualplan",
                        verbose_name="Haushaltsplan",
                    ),
                ),
                (
                    "parent",
                    models.ForeignKey(
                        blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
                    ),
                ),
                ("requester", models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to="core.requester")),
            ],
        ),
        migrations.AddField(
            model_name="cashtransfer",
            name="budget",
            field=models.ForeignKey(
                blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
            ),
        ),
        migrations.AddField(
            model_name="internalbooking",
            name="budget",
            field=models.ForeignKey(
                blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
            ),
        ),
        migrations.AddField(
            model_name="issuedinvoice",
            name="budget",
            field=models.ForeignKey(
                blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
            ),
        ),
        migrations.AddField(
            model_name="receivedinvoice",
            name="budget",
            field=models.ForeignKey(
                blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
            ),
        ),
        migrations.AddField(
            model_name="zerosumbooking",
            name="budget",
            field=models.ForeignKey(
                blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to="core.budget"
            ),
        ),
        migrations.AddField(
            model_name="request",
            name="budget",
            field=models.OneToOneField(
                null=True, on_delete=django.db.models.deletion.CASCADE, related_name="request", to="core.budget"
            ),
        ),
        migrations.RunPython(code=split_budget_request),
        migrations.AlterField(
            model_name="request",
            name="budget",
            field=models.OneToOneField(
                on_delete=django.db.models.deletion.CASCADE, related_name="request", to="core.budget"
            ),
        ),
        migrations.RemoveField(
            model_name="receivedinvoice",
            name="request",
        ),
        migrations.RemoveField(
            model_name="request",
            name="annual_plan",
        ),
        migrations.RemoveField(
            model_name="request",
            name="date",
        ),
        migrations.RemoveField(
            model_name="request",
            name="estimated_amount",
        ),
        migrations.RemoveField(
            model_name="request",
            name="name",
        ),
        migrations.RemoveField(
            model_name="request",
            name="requester",
        ),
        migrations.RemoveField(
            model_name="request",
            name="status",
        ),
    ]
